org.apache.fop.fo

## Interface FOValidationEventProducer

-     public interface FOValidationEventProducer

  Event producer interface for XSL-FO validation messages.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface and Description
    --- | ---
    `static class` | `FOValidationEventProducer.Provider` Provider class for the event producer.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `altTextMissing(java.lang.Object source, java.lang.String foElement, org.xml.sax.Locator loc)` Alternate text is missing for a graphic element.
    `void` | `changeBarClassNotUnique(java.lang.Object source, java.lang.String elementName, java.lang.String name, org.xml.sax.Locator loc)` A class for change bars is not unique.
    `void` | `changeBarNoBegin(java.lang.Object source, java.lang.String elementName, org.xml.sax.Locator loc)` Change bar ended without a start of bar occurred
    `void` | `changeBarWrongAncestor(java.lang.Object source, java.lang.String elementName, org.xml.sax.Locator loc)` Change bar not descendant of fo:flow or fo:static-content
    `void` | `changeBarWrongStacking(java.lang.Object source, java.lang.String elementName, java.lang.String beginName, java.lang.String endName, org.xml.sax.Locator loc)` Change bars were not stacked correctly
    `void` | `colorProfileNameNotUnique(java.lang.Object source, java.lang.String elementName, java.lang.String name, org.xml.sax.Locator loc)` There are multiple color profiles defined with the same name.
    `void` | `columnCountErrorOnRegionBodyOverflowScroll(java.lang.Object source, java.lang.String elementName, org.xml.sax.Locator loc)` If overflow property is set to "scroll", a column-count other than "1" may not be specified.
    `void` | `duplicateFlowNameInPageSequence(java.lang.Object source, java.lang.String elementName, java.lang.String flowName, org.xml.sax.Locator loc)` There are multiple flows with the same name.
    `void` | `emptyDocument(java.lang.Object source)` No FO document was found.
    `void` | `flowNameNotMapped(java.lang.Object source, java.lang.String elementName, java.lang.String flowName, org.xml.sax.Locator loc)` A flow name could not be mapped to a region.
    `void` | `idNotUnique(java.lang.Object source, java.lang.String elementName, java.lang.String id, boolean canRecover, org.xml.sax.Locator loc)` An id was used twice in a document.
    `void` | `illegalRegionName(java.lang.Object source, java.lang.String elementName, java.lang.String regionName, org.xml.sax.Locator loc)` An illegal region name was used.
    `void` | `invalidChild(java.lang.Object source, java.lang.String elementName, org.apache.xmlgraphics.util.QName offendingNode, java.lang.String ruleViolated, org.xml.sax.Locator loc)` An invalid child was encountered.
    `void` | `invalidFORoot(java.lang.Object source, java.lang.String elementName, org.xml.sax.Locator loc)` fo:root must be root.
    `void` | `invalidProperty(java.lang.Object source, java.lang.String elementName, org.apache.xmlgraphics.util.QName attr, boolean canRecover, org.xml.sax.Locator loc)` An invalid property was found.
    `void` | `invalidPropertyValue(java.lang.Object source, java.lang.String elementName, java.lang.String propName, java.lang.String propValue, PropertyException e, org.xml.sax.Locator loc)` An invalid property value was encountered.
    `void` | `markerBlockContainerAbsolutePosition(java.lang.Object source, org.xml.sax.Locator loc)` An fo:marker appears as initial descendant in an fo:block-container that generates absolutely positioned areas
    `void` | `markerCloningFailed(java.lang.Object source, java.lang.String markerClassName, FOPException fe, org.xml.sax.Locator loc)` Indicates a problem while cloning a marker (ex.
    `void` | `markerNotInitialChild(java.lang.Object source, java.lang.String elementName, java.lang.String mcname, org.xml.sax.Locator loc)` A marker is not an initial child on a node.
    `void` | `markerNotUniqueForSameParent(java.lang.Object source, java.lang.String elementName, java.lang.String mcname, org.xml.sax.Locator loc)` A marker class name is not unique within the same parent.
    `void` | `masterNameNotUnique(java.lang.Object source, java.lang.String elementName, java.lang.String name, org.xml.sax.Locator loc)` There are multiple page masters defined with the same name.
    `void` | `masterNotFound(java.lang.Object source, java.lang.String elementName, java.lang.String masterReference, org.xml.sax.Locator loc)` A page master could not be found.
    `void` | `missingChildElement(java.lang.Object source, java.lang.String elementName, java.lang.String contentModel, boolean canRecover, org.xml.sax.Locator loc)` A required child element is missing.
    `void` | `missingLinkDestination(java.lang.Object source, java.lang.String elementName, org.xml.sax.Locator loc)` Missing internal-/external-destination on basic-link or bookmark.
    `void` | `missingProperty(java.lang.Object source, java.lang.String elementName, java.lang.String propertyName, org.xml.sax.Locator loc)` An element is missing a required property.
    `void` | `nodeOutOfOrder(java.lang.Object source, java.lang.String elementName, java.lang.String tooLateNode, java.lang.String tooEarlyNode, boolean canRecover, org.xml.sax.Locator loc)` The node order is wrong.
    `void` | `nonZeroBorderPaddingOnRegion(java.lang.Object source, java.lang.String elementName, java.lang.String regionName, boolean canRecover, org.xml.sax.Locator loc)` A non-zero border and/or padding has been encountered on a region.
    `void` | `notSupportedChild(java.lang.Object source, java.lang.String elementName, org.apache.xmlgraphics.util.QName offendingNode, org.xml.sax.Locator loc)` A valid but not yet supported child was encountered.
    `void` | `regionNameMappedToMultipleRegionClasses(java.lang.Object source, java.lang.String regionName, java.lang.String defaultRegionClass1, java.lang.String defaultRegionClass2, org.xml.sax.Locator loc)` A region name is mapped to multiple region classes.
    `void` | `tooManyNodes(java.lang.Object source, java.lang.String elementName, org.apache.xmlgraphics.util.QName offendingNode, org.xml.sax.Locator loc)` Too many child nodes.
    `void` | `unimplementedFeature(java.lang.Object source, java.lang.String elementName, java.lang.String feature, org.xml.sax.Locator loc)` A feature is not supported, yet.
    `void` | `unknownFormattingObject(java.lang.Object source, java.lang.String elementName, org.apache.xmlgraphics.util.QName offendingNode, org.xml.sax.Locator loc)` An unknown/unsupported formatting object has been encountered.
    `void` | `warnOnInvalidPropertyValue(java.lang.Object source, java.lang.String elementName, java.lang.String propName, java.lang.String propValue, PropertyException e, org.xml.sax.Locator loc)` An invalid property value was encountered.

- - ### Method Detail

    - #### tooManyNodes

          void tooManyNodes(java.lang.Object source,
                          java.lang.String elementName,
                          org.apache.xmlgraphics.util.QName offendingNode,
                          org.xml.sax.Locator loc)
                            throws ValidationException

      Too many child nodes.
      Parameters:
        `source` - the event source
        `elementName` - the name of the context node
        `offendingNode` - the offending node
        `loc` - the location of the error or null
      Throws:
        `ValidationException` - the validation error provoked by the method call
      Event severity level:
        FATAL

    - #### nodeOutOfOrder

          void nodeOutOfOrder(java.lang.Object source,
                            java.lang.String elementName,
                            java.lang.String tooLateNode,
                            java.lang.String tooEarlyNode,
                            boolean canRecover,
                            org.xml.sax.Locator loc)
                              throws ValidationException

      The node order is wrong.
      Parameters:
        `source` - the event source
        `elementName` - the name of the context node
        `tooLateNode` - string name of node that should be earlier in document
        `tooEarlyNode` - string name of node that should be later in document
        `canRecover` - indicates whether FOP can recover from this problem and continue working
        `loc` - the location of the error or null
      Throws:
        `ValidationException` - the validation error provoked by the method call

    - #### invalidChild

          void invalidChild(java.lang.Object source,
                          java.lang.String elementName,
                          org.apache.xmlgraphics.util.QName offendingNode,
                          java.lang.String ruleViolated,
                          org.xml.sax.Locator loc)
                            throws ValidationException

      An invalid child was encountered.
      Parameters:
        `source` - the event source
        `elementName` - the name of the context node
        `offendingNode` - the offending node
        `ruleViolated` - the rule that was violated or null
        `loc` - the location of the error or null
      Throws:
        `ValidationException` - the validation error provoked by the method call

    - #### notSupportedChild

          void notSupportedChild(java.lang.Object source,
                               java.lang.String elementName,
                               org.apache.xmlgraphics.util.QName offendingNode,
                               org.xml.sax.Locator loc)
                                 throws ValidationException

      A valid but not yet supported child was encountered.
      Parameters:
        `source` - the event source
        `elementName` - the name of the context node
        `offendingNode` - the offending node
        `loc` - the location of the error or null
      Throws:
        `ValidationException` - the validation error provoked by the method call

    - #### missingChildElement

          void missingChildElement(java.lang.Object source,
                                 java.lang.String elementName,
                                 java.lang.String contentModel,
                                 boolean canRecover,
                                 org.xml.sax.Locator loc)
                                   throws ValidationException

      A required child element is missing.
      Parameters:
        `source` - the event source
        `elementName` - the name of the context node
        `contentModel` - the expected content model
        `canRecover` - indicates whether FOP can recover from this problem and continue working
        `loc` - the location of the error or null
      Throws:
        `ValidationException` - the validation error provoked by the method call
      Event severity level:
        FATAL

    - #### missingProperty

          void missingProperty(java.lang.Object source,
                             java.lang.String elementName,
                             java.lang.String propertyName,
                             org.xml.sax.Locator loc)
                               throws ValidationException

      An element is missing a required property.
      Parameters:
        `source` - the event source
        `elementName` - the name of the context node
        `propertyName` - the name of the missing property
        `loc` - the location of the error or null
      Throws:
        `ValidationException` - the validation error provoked by the method call
      Event severity level:
        FATAL

    - #### idNotUnique

          void idNotUnique(java.lang.Object source,
                         java.lang.String elementName,
                         java.lang.String id,
                         boolean canRecover,
                         org.xml.sax.Locator loc)
                           throws ValidationException

      An id was used twice in a document.
      Parameters:
        `source` - the event source
        `elementName` - the name of the context node
        `id` - the id that was reused
        `canRecover` - indicates whether FOP can recover from this problem and continue working
        `loc` - the location of the error or null
      Throws:
        `ValidationException` - the validation error provoked by the method call
      Event severity level:
        FATAL

    - #### colorProfileNameNotUnique

          void colorProfileNameNotUnique(java.lang.Object source,
                                       java.lang.String elementName,
                                       java.lang.String name,
                                       org.xml.sax.Locator loc)

      There are multiple color profiles defined with the same name.
      Parameters:
        `source` - the event source
        `elementName` - the name of the context node
        `name` - the duplicate color profile name
        `loc` - the location of the error or null
      Event severity level:
        WARN

    - #### masterNameNotUnique

          void masterNameNotUnique(java.lang.Object source,
                                 java.lang.String elementName,
                                 java.lang.String name,
                                 org.xml.sax.Locator loc)
                                   throws ValidationException

      There are multiple page masters defined with the same name.
      Parameters:
        `source` - the event source
        `elementName` - the name of the context node
        `name` - the duplicate page master name
        `loc` - the location of the error or null
      Throws:
        `ValidationException` - the validation error provoked by the method call
      Event severity level:
        FATAL

    - #### markerBlockContainerAbsolutePosition

          void markerBlockContainerAbsolutePosition(java.lang.Object source,
                                                  org.xml.sax.Locator loc)

      An fo:marker appears as initial descendant in an fo:block-container that generates absolutely positioned areas
      Parameters:
        `source` - the event source
        `loc` - the location of the error (possibly null)
      Event severity level:
        ERROR

    - #### markerNotInitialChild

          void markerNotInitialChild(java.lang.Object source,
                                   java.lang.String elementName,
                                   java.lang.String mcname,
                                   org.xml.sax.Locator loc)

      A marker is not an initial child on a node.
      Parameters:
        `source` - the event source
        `elementName` - the name of the context node
        `mcname` - the marker class name
        `loc` - the location of the error or null
      Event severity level:
        ERROR

    - #### markerNotUniqueForSameParent

          void markerNotUniqueForSameParent(java.lang.Object source,
                                          java.lang.String elementName,
                                          java.lang.String mcname,
                                          org.xml.sax.Locator loc)

      A marker class name is not unique within the same parent.
      Parameters:
        `source` - the event source
        `elementName` - the name of the context node
        `mcname` - the marker class name
        `loc` - the location of the error or null
      Event severity level:
        ERROR

    - #### invalidProperty

          void invalidProperty(java.lang.Object source,
                             java.lang.String elementName,
                             org.apache.xmlgraphics.util.QName attr,
                             boolean canRecover,
                             org.xml.sax.Locator loc)
                               throws ValidationException

      An invalid property was found.
      Parameters:
        `source` - the event source
        `elementName` - the name of the context node
        `attr` - the invalid attribute
        `canRecover` - indicates whether FOP can recover from this problem and continue working
        `loc` - the location of the error or null
      Throws:
        `ValidationException` - the validation error provoked by the method call
      Event severity level:
        FATAL

    - #### invalidPropertyValue

          void invalidPropertyValue(java.lang.Object source,
                                  java.lang.String elementName,
                                  java.lang.String propName,
                                  java.lang.String propValue,
                                  PropertyException e,
                                  org.xml.sax.Locator loc)

      An invalid property value was encountered.
      Parameters:
        `source` - the event source
        `elementName` - the name of the context node
        `propName` - the property name
        `propValue` - the property value
        `e` - the property exception caused by the invalid value
        `loc` - the location of the error or null
      Event severity level:
        ERROR

    - #### warnOnInvalidPropertyValue

          void warnOnInvalidPropertyValue(java.lang.Object source,
                                        java.lang.String elementName,
                                        java.lang.String propName,
                                        java.lang.String propValue,
                                        PropertyException e,
                                        org.xml.sax.Locator loc)

      An invalid property value was encountered.
      Parameters:
        `source` - the event source
        `elementName` - the name of the context node
        `propName` - the property name
        `propValue` - the property value
        `e` - the property exception caused by the invalid value
        `loc` - the location of the error or null
      Event severity level:
        WARN

    - #### unimplementedFeature

          void unimplementedFeature(java.lang.Object source,
                                  java.lang.String elementName,
                                  java.lang.String feature,
                                  org.xml.sax.Locator loc)

      A feature is not supported, yet.
      Parameters:
        `source` - the event source
        `elementName` - the name of the context node
        `feature` - the unsupported feature
        `loc` - the location of the error or null
      Event severity level:
        WARN

    - #### missingLinkDestination

          void missingLinkDestination(java.lang.Object source,
                                    java.lang.String elementName,
                                    org.xml.sax.Locator loc)
                                      throws ValidationException

      Missing internal-/external-destination on basic-link or bookmark.
      Parameters:
        `source` - the event source
        `elementName` - the name of the context node
        `loc` - the location of the error or null
      Throws:
        `ValidationException` - the validation error provoked by the method call
      Event severity level:
        FATAL

    - #### markerCloningFailed

          void markerCloningFailed(java.lang.Object source,
                                 java.lang.String markerClassName,
                                 FOPException fe,
                                 org.xml.sax.Locator loc)

      Indicates a problem while cloning a marker (ex. due to invalid property values).
      Parameters:
        `source` - the event source
        `markerClassName` - the "marker-class-name" of the marker
        `fe` - the FOP exception that cause this problem
        `loc` - the location of the error or null
      Event severity level:
        ERROR

    - #### regionNameMappedToMultipleRegionClasses

          void regionNameMappedToMultipleRegionClasses(java.lang.Object source,
                                                     java.lang.String regionName,
                                                     java.lang.String defaultRegionClass1,
                                                     java.lang.String defaultRegionClass2,
                                                     org.xml.sax.Locator loc)
                                                       throws ValidationException

      A region name is mapped to multiple region classes.
      Parameters:
        `source` - the event source
        `regionName` - the region name
        `defaultRegionClass1` - the first default region class
        `defaultRegionClass2` - the second default region class
        `loc` - the location of the error or null
      Throws:
        `ValidationException` - the validation error provoked by the method call
      Event severity level:
        FATAL

    - #### duplicateFlowNameInPageSequence

          void duplicateFlowNameInPageSequence(java.lang.Object source,
                                             java.lang.String elementName,
                                             java.lang.String flowName,
                                             org.xml.sax.Locator loc)
                                               throws ValidationException

      There are multiple flows with the same name.
      Parameters:
        `source` - the event source
        `elementName` - the name of the context node
        `flowName` - the flow name
        `loc` - the location of the error or null
      Throws:
        `ValidationException` - the validation error provoked by the method call
      Event severity level:
        FATAL

    - #### flowNameNotMapped

          void flowNameNotMapped(java.lang.Object source,
                               java.lang.String elementName,
                               java.lang.String flowName,
                               org.xml.sax.Locator loc)
                                 throws ValidationException

      A flow name could not be mapped to a region.
      Parameters:
        `source` - the event source
        `elementName` - the name of the context node
        `flowName` - the flow name
        `loc` - the location of the error or null
      Throws:
        `ValidationException` - the validation error provoked by the method call
      Event severity level:
        FATAL

    - #### masterNotFound

          void masterNotFound(java.lang.Object source,
                            java.lang.String elementName,
                            java.lang.String masterReference,
                            org.xml.sax.Locator loc)
                              throws ValidationException

      A page master could not be found.
      Parameters:
        `source` - the event source
        `elementName` - the name of the context node
        `masterReference` - the page master reference
        `loc` - the location of the error or null
      Throws:
        `ValidationException` - the validation error provoked by the method call
      Event severity level:
        FATAL

    - #### illegalRegionName

          void illegalRegionName(java.lang.Object source,
                               java.lang.String elementName,
                               java.lang.String regionName,
                               org.xml.sax.Locator loc)
                                 throws ValidationException

      An illegal region name was used.
      Parameters:
        `source` - the event source
        `elementName` - the name of the context node
        `regionName` - the region name
        `loc` - the location of the error or null
      Throws:
        `ValidationException` - the validation error provoked by the method call
      Event severity level:
        FATAL

    - #### nonZeroBorderPaddingOnRegion

          void nonZeroBorderPaddingOnRegion(java.lang.Object source,
                                          java.lang.String elementName,
                                          java.lang.String regionName,
                                          boolean canRecover,
                                          org.xml.sax.Locator loc)
                                            throws ValidationException

      A non-zero border and/or padding has been encountered on a region.
      Parameters:
        `source` - the event source
        `elementName` - the name of the context node
        `regionName` - the region name
        `canRecover` - indicates whether FOP can recover from this problem and continue working
        `loc` - the location of the error or null
      Throws:
        `ValidationException` - the validation error provoked by the method call
      Event severity level:
        FATAL

    - #### columnCountErrorOnRegionBodyOverflowScroll

          void columnCountErrorOnRegionBodyOverflowScroll(java.lang.Object source,
                                                        java.lang.String elementName,
                                                        org.xml.sax.Locator loc)
                                                          throws ValidationException

      If overflow property is set to "scroll", a column-count other than "1" may not be specified.
      Parameters:
        `source` - the event source
        `elementName` - the name of the context node
        `loc` - the location of the error or null
      Throws:
        `ValidationException` - the validation error provoked by the method call
      Event severity level:
        FATAL

    - #### invalidFORoot

          void invalidFORoot(java.lang.Object source,
                           java.lang.String elementName,
                           org.xml.sax.Locator loc)
                             throws ValidationException

      fo:root must be root.
      Parameters:
        `source` - the event source
        `elementName` - the name of the context node
        `loc` - the location of the error or null
      Throws:
        `ValidationException` - the validation error provoked by the method call
      Event severity level:
        FATAL

    - #### emptyDocument

          void emptyDocument(java.lang.Object source)
                             throws ValidationException

      No FO document was found.
      Parameters:
        `source` - the event source
      Throws:
        `ValidationException` - the validation error provoked by the method call
      Event severity level:
        FATAL

    - #### unknownFormattingObject

          void unknownFormattingObject(java.lang.Object source,
                                     java.lang.String elementName,
                                     org.apache.xmlgraphics.util.QName offendingNode,
                                     org.xml.sax.Locator loc)

      An unknown/unsupported formatting object has been encountered.
      Parameters:
        `source` - the event source
        `elementName` - the name of the context node
        `offendingNode` - the offending node
        `loc` - the location of the error or null
      Event severity level:
        WARN

    - #### changeBarClassNotUnique

          void changeBarClassNotUnique(java.lang.Object source,
                                     java.lang.String elementName,
                                     java.lang.String name,
                                     org.xml.sax.Locator loc)

      A class for change bars is not unique.
      Parameters:
        `source` - the event source
        `elementName` - the name of the context node
        `name` - the class name
        `loc` - the location of the error or null
      Event severity level:
        FATAL

    - #### changeBarWrongStacking

          void changeBarWrongStacking(java.lang.Object source,
                                    java.lang.String elementName,
                                    java.lang.String beginName,
                                    java.lang.String endName,
                                    org.xml.sax.Locator loc)

      Change bars were not stacked correctly
      Parameters:
        `source` - the event source
        `elementName` - the name of the context node
        `beginName` - the class name of the beginning change bar
        `endName` - the class name of the ending change bar
        `loc` - the location of the error or null
      Event severity level:
        FATAL

    - #### changeBarNoBegin

          void changeBarNoBegin(java.lang.Object source,
                              java.lang.String elementName,
                              org.xml.sax.Locator loc)

      Change bar ended without a start of bar occurred
      Parameters:
        `source` - the event source
        `elementName` - the name of the context node
        `loc` - the location of the error or null
      Event severity level:
        FATAL

    - #### changeBarWrongAncestor

          void changeBarWrongAncestor(java.lang.Object source,
                                    java.lang.String elementName,
                                    org.xml.sax.Locator loc)

      Change bar not descendant of fo:flow or fo:static-content
      Parameters:
        `source` - the event source
        `elementName` - the name of the context node
        `loc` - the location of the error or null
      Event severity level:
        FATAL

    - #### altTextMissing

          void altTextMissing(java.lang.Object source,
                            java.lang.String foElement,
                            org.xml.sax.Locator loc)

      Alternate text is missing for a graphic element.
      Parameters:
        `source` - the event source
        `foElement` - name of the element (external-graphic or instream-foreign-object)
        `loc` - the location of the error or null
      Event severity level:
        WARN

Copyright 1999-2019 The Apache Software Foundation. All Rights Reserved.